
Global CamSpeed = 0.6 , CamMode = 0 , RenderMode = 0, FullScreen = 0
Global KeyX, KeyY, RollZ, RotX, RotY, MouseX, MouseY, FPS, VSync = 1

#SQRT13 = 0.57735026

Declare InitWorld()
Declare Keyboard()
Declare MakeMesh()

Procedure InitWorld()
  
Global Mesh$
;Mesh$ = GetFilePart(OpenFileRequester("MeshViewer",GetCurrentDirectory() , "mesh (*.mesh) | *.mesh", 0))

InitEngine3D() 
InitSprite()
InitKeyboard()
InitMouse()

UsePNGImageDecoder()
UseJPEGImageDecoder()

Add3DArchive("\", #PB_3DArchive_FileSystem) 
AntialiasingMode(#PB_AntialiasingMode_x6)
;Parse3DScripts()

If Not FullScreen
  OpenWindow(0,0,0,1280,960,"Stryder",#PB_Window_SystemMenu|#PB_Window_ScreenCentered) 
  OpenWindowedScreen(WindowID(0),0,0,1280,960,0,0,0,VSync) 
 Else
  ExamineDesktops()
  OpenScreen(DesktopWidth(0),DesktopHeight(0),32,"",VSync)
EndIf

CreateCamera(0, 0, 0, 100, 100)
CameraLocate(0, -30, 30,-40)
RotateCamera(0,-90,0, 180)

MakeMesh() ;LoadMesh(1,Mesh$)
CreateEntity(1, MeshID(1), MaterialID(1),0,0,0)
ResizeEntity(1, 5,5,5)

;CreateLight(0,$FFFFFF,0,40,0,#PB_Light_Spot)
;SpotLightRange(0,0, 90, 3)
;AmbientColor($FFFFFF)

LoadTexture(0,"plane.jpg") 
CreateMaterial(0, TextureID(0))
CreatePlane(0, 20, 20, 10, 10, 10, 10)
CreateEntity(0,MeshID(0), MaterialID(0), 0, 0, 0)

CameraLookAt(0,EntityX(1),EntityY(1),EntityZ(1))

EndProcedure

Procedure Keyboard()
  
ExamineKeyboard()
     
If KeyboardPushed(#PB_Key_A)
  keyx = -1
 ElseIf KeyboardPushed(#PB_Key_D)
   keyx = 1 
 Else
  keyx = 0
EndIf

If KeyboardReleased(#PB_Key_A)
 
ElseIf KeyboardReleased(#PB_Key_D)
 
EndIf

If KeyboardPushed(#PB_Key_W)
  keyy = -1 
ElseIf KeyboardPushed(#PB_Key_S)
  keyy = 1 
Else
  keyy = 0
EndIf

If KeyboardReleased(#PB_Key_PageUp)
  rollz = 1 
ElseIf KeyboardReleased(#PB_Key_PageDown)
 rollz = 0
EndIf

If KeyboardReleased(#PB_Key_Space)
 
EndIf

If KeyboardReleased(#PB_Key_F1)
 
EndIf

If KeyboardReleased(#PB_Key_F2) 
 Rendermode = Rendermode + 1 
 Select Rendermode
   Case 0 : CameraRenderMode(0, #PB_Camera_Textured)
   Case 1 : CameraRenderMode(0, #PB_Camera_Wireframe)
   Case 2 : CameraRenderMode(0, #PB_Camera_Plot)
 EndSelect
 If Rendermode = 2 : Rendermode = -1 : EndIf
EndIf
 
 If KeyboardReleased(#PB_Key_F3)
   ;If CamMode = #True : CamMode = #False : Else : CamMode = #True : EndIf
 EndIf
      
ExamineMouse()
     
rotx = 0 : roty = 0
mousex = -MouseDeltaX()
mousey = -MouseDeltaY()
     
If MouseButton(#PB_MouseButton_Right)
 rotx = mousey
 roty = mousex
 mousex = 0
 mousey = 0
EndIf
     
EndProcedure

Procedure MakeMesh()

LoadImage(0,"pickaxe.png")
Width  = ImageWidth(0)-1
Height = ImageHeight(0)-1

StartDrawing(ImageOutput(0))
CreateMesh(1)

For y = 0 To Height
For x = 0 To Width

If Point(x,y) <> 0

AddMeshVertex(0, 1, 0)
MeshVertexColor(RGB(255, 0, 0))
AddMeshVertex(1, 1, 0)
MeshVertexColor(RGB(255, 0, 0))
AddMeshVertex(1, 0, 0)
MeshVertexColor(RGB(255, 0, 0))
AddMeshVertex(0, 0, 0)
MeshVertexColor(RGB(255, 0, 255))
AddMeshVertex(0, 1, 1)
MeshVertexColor(RGB(255, 0, 0))
AddMeshVertex(1, 1, 1)
MeshVertexColor(RGB(255, 0, 255))
AddMeshVertex(1, 0, 1)
MeshVertexColor(RGB(255, 0, 0))
AddMeshVertex(0, 0, 1)
MeshVertexColor(RGB(255, 0, 0))
;MeshVertexNormal(-#SQRT13,-#SQRT13,#SQRT13)

AddMeshFace(0, 2, 3)
AddMeshFace(0, 1, 2)
AddMeshFace(1, 6, 2)
AddMeshFace(1, 5, 6)
AddMeshFace(4, 6, 5)
AddMeshFace(4, 7, 6)
AddMeshFace(0, 7, 4)
AddMeshFace(0, 3, 7)
AddMeshFace(0, 5, 1)
AddMeshFace(0, 4, 5)
AddMeshFace(2, 7, 3)
AddMeshFace(2, 6, 7)

EndIf

Next x
Next y
    
FinishMesh()
StopDrawing()

;TransformMesh(1,0,0,0,0.05,0.05,0.05,0,0,0)
CreateMaterial(1, LoadTexture(1, "clouds.jpg"))
MaterialAmbientColor(1, #PB_Material_AmbientColors)

EndProcedure


InitWorld()

Repeat  
  
 If Not Fullscreen
 Select WaitWindowEvent(1) 
 Case #PB_Event_CloseWindow 
 Quit = #True 
 EndSelect 
 EndIf
 
 Keyboard()
 RotateEntity(1, 0, 0, rotx, #PB_Relative)
 RotateCamera(0, mousey, mousex, 0,#PB_Relative)
 MoveCamera  (0, keyx*CamSpeed, 0, keyy*CamSpeed)  

 FPS = Engine3DFrameRate(#PB_Engine3D_Current)
 RenderWorld() 
 
 FlipBuffers()
 
Until KeyboardPushed(#PB_Key_Escape) Or Quit = #True

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 41
; FirstLine = 18
; Folding = 0
; EnableXP